##2016-08-02 - Release 2.2.0
### Summary

This release includes new features as well as bug fixes.

The overview data model now contains more information. It used to only contain the top 10 nodes based on an issue count.
Now, the overview data model contains information about all nodes the overview is based on and with more details per node
in the form of number of errors, warning, and catalog differences. This information is now used to better order the output
as well as being easier to consume by custom post-processing and presentation logic.

Attempting to use a node for which there was no available fact-set caused an error that did not indicate what the real problem was.
Now, instead, deactivated or non existing nodes will be skipped. This supports the use case when a compilation is requested
where the list of nodes to compile for was generated from a list of certificates (which may contain deactivated nodes).

There were errors in the calculation and presentation of issue counts where the same problem could be counted multiple times.
This is now corrected.

Catalog preview could not compute the difference between resources that used an Integer as resource title. This is now fixed.

##2016-05-14 - Release 2.1.0
### Summary

This release is the first Open Source Release of Catalog Preview, and it adds one new feature.

Previously a preview environment was always required for migration checking. Now catalog preview will instead
compile a catalog twice in the baseline environment, once with the "current" 3.x parser, and once with the "future" 4.x
parser. This is achieved by simply not specifying the `--preview-environment` flag.

Errors in the documentation are also corrected in this release.

##2015-12-08 - Release 2.0.3
###Summary

This release adds support for the latest 2015.3 release of PE, and includes one bug fix.

Previously, the wrong environment was in effect for Hiera causing the preview environment to use the same Hiera data as the non-preview env. For most users the two sets of data would be identical and problem did then not occur. The problem was in Puppet and is fixed in later Puppet releases. This bug fix in catalog preview works around the problem in older Puppet releases, and with this fix Hiera now get the correct environment and subsequently perform lookups the correct way even when Hiera data is different between the two environments compared by catalog preview.


##2015-08-04 - Release 2.0.2
###Summary

This release includes several bug fixes.

Previously when running with the Puppet 4x parser, --view diff_nodes would produce an incorrect list of nodes both with --last and without. That bug has been fixed and now the correct list of nodes will be printed.

With previous versions of PuppetDB, catalog_preview used its own variant of the fact terminus. With the release of PuppetDB 3, catalog_preview needs to use PuppetDB's fact terminus instead which meant it was broken with PuppetDB 3. That bug has been fixed and catalog_preview will now adjust accordingly based on the version of PuppetDB being used.

Previously, catalog_preview diffs were not displaying tag parameters in a human readable format. It would just display a Ruby object reference. Now that bug has been fixed and the tags are displayed properly.

##2015-07-14 - Release 2.0.1
###Summary

This release includes a minor bug fix and additional version checking.

An exclude entry that has a null `attributes` property will completely exclude the resources that it will match. When this happens, it is important to also exclude all edges where the resource is either the source or the target. This release has been fixed to ensure that happens.

Due to a bug in PE 3.8.0 which prevents you from setting your parser per environment, the documented migration work flow does not work with PE 3.8.0. This release adds some additional version checking so that the user will be warned when they are trying to migrate with PE 3.8.0.

##2015-06-30 - Release 2.0.0
###Summary

This release introduces the ability to compile and diff multiple nodes with one invocation of the preview command. The command can now also aggregate and correlate issues/diffs across multiple nodes using a new `--view overview` option.

The `--last` option can now reload information from one or multiple nodes. This enables producing different views/reports of different nodes/sets of nodes once compiled.

A `--clean` option adds the ability to clean up output generated by preview for a given set of nodes, or for all.

The `--migrate` option now takes an argument (in this released always `3.8/4.0`). The argument works in conjunction with the version of puppet in use. Puppet versions >= 3.8.0 < 4.0.0 supports the 3.8/4.0 migration checking option. Later versions of puppet/catalog preview may add support for other migration checks.

Short form options for `--preview_environment` (`--pe`) and `--baseline_environment` (`--be`) have been added.

An `--excludes exclusion_file` option has ben added that allows resources to be excluded from
the catalog diff processing. It is possible to exclude all resource of a type, all attributes
of a given resource title, or specific attributes of a type, or for a title. This can be used
for resources that have values that are known to always differ between compilations e.g because attributes are set to random values, a value based on date/time, etc.

The `--help` command includes a description of the migration warnings that are produced in the
preview_log and explains how to deal with such warnings.

This release also updates the module's README to improve usability by including a small dictionary of terms and explanations for the migration specific warnings produced by the `migrate 3.8/4.0` option.

##2015-04-05 - Release 1.0.1
###Summary

This release updates the module's README to improve usability.

